#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

struct Line {
	mutable ll k, m, p;
	bool operator<(const Line& o) const { return k < o.k; }
	bool operator<(ll x) const { return p < x; }
};

struct LineContainer : multiset<Line, less<>> {
	// (for doubles, use inf = 1/.0, div(a,b) = a/b)
	static const ll inf = LLONG_MAX;
	ll div(ll a, ll b) { // floored division
		return a / b - ((a ^ b) < 0 && a % b); }
	bool isect(iterator x, iterator y) {
		if (y == end()) return x->p = inf, 0;
		if (x->k == y->k) x->p = x->m > y->m ? inf : -inf;
		else x->p = div(y->m - x->m, x->k - y->k);
		return x->p >= y->p;
	}
	void add(ll k, ll m) {
		auto z = insert({k, m, 0}), y = z++, x = y;
		while (isect(y, z)) z = erase(z);
		if (x != begin() && isect(--x, y)) isect(x, y = erase(y));
		while ((y = x) != begin() && (--x)->p >= y->p)
			isect(x, erase(y));
	}
	ll query(ll x) {
		assert(!empty());
		auto l = *lower_bound(x);
		return l.k * x + l.m;
	}
};

long long solve(std::vector<int> H_in, std::vector<int> W_in) {
	int n = (int)H_in.size();
	vector<ll> h(H_in.begin(), H_in.end()), w(W_in.begin(), W_in.end());

	ll ans = 0;
	auto solve = [&]() {
	    LineContainer W, H;
	    ll best = 0;
	    for(int i = 0; i < n; i++) {
	        W.add(w[i], best);
	        H.add(h[i], best);
	        best = max(best, max(W.query(h[i]), H.query(w[i])));
	    }
	    ans = max(ans, best);
	};
	
	int start = (int)(max_element(all(h))-h.begin());
	rotate(h.begin(), h.begin()+start, h.end());
	rotate(w.begin(), w.begin()+start, w.end());
	solve();
	reverse(all(h));
	reverse(all(w));
	rotate(h.begin(), h.begin()+n-1, h.end());
	rotate(w.begin(), w.begin()+n-1, w.end());
	solve();
	
	return ans;
}
